Index: kernel/tgb.cc
===================================================================
--- kernel/tgb.cc	(revision a41623dd1e56318466dc81751481d37d19489c7b)
+++ kernel/tgb.cc	(revision 410ea0fb1e22ebcb52e33b6789cf294a2d1f663b)
@@ -851,52 +960,58 @@
 
 
-static void cleanS(kStrategy strat, slimgb_alg* c)
-{
-  int i=0;
+static void
+cleanS (kStrategy strat, slimgb_alg * c)
+{
+  int i = 0;
   LObject P;
-  while(i<=strat->sl)
-  {
-    P.p=strat->S[i];
-    P.sev=strat->sevS[i];
+  while (i <= strat->sl)
+  {
+    P.p = strat->S[i];
+    P.sev = strat->sevS[i];
     //int dummy=strat->sl;
     //if(kFindDivisibleByInS(strat,&dummy,&P)!=i)
-    if (kFindDivisibleByInS_easy(strat,P.p,P.sev)!=i)
-    {
-      deleteInS(i,strat);
+    if (kFindDivisibleByInS_easy (strat, P.p, P.sev) != i)
+    {
+      deleteInS (i, strat);
       //remember destroying poly
-      BOOLEAN found=FALSE;
+      BOOLEAN found = FALSE;
       int j;
-      for(j=0;j<c->n;j++)
-      {
-        if(c->S->m[j]==P.p)
-        {
-          found=TRUE;
-          break;
-        }
+      for (j = 0; j < c->n; j++)
+      {
+	if (c->S->m[j] == P.p)
+	{
+	  found = TRUE;
+	  break;
+	}
       }
       if (!found)
-        pDelete(&P.p);
+	pDelete (&P.p);
       //remember additional reductors
     }
-    else i++;
-  }
-}
-static int bucket_guess(kBucket* bucket)
-{
-  int sum=0;
+    else
+      i++;
+  }
+}
+
+static int
+bucket_guess (kBucket * bucket)
+{
+  int sum = 0;
   int i;
-  for (i=bucket->buckets_used;i>=0;i--)
-  {
-    if(bucket->buckets[i])
-       sum+=bucket->buckets_length[i];
+  for (i = bucket->buckets_used; i >= 0; i--)
+  {
+    if (bucket->buckets[i])
+      sum += bucket->buckets_length[i];
   }
   return sum;
 }
 
-static int add_to_reductors(slimgb_alg* c, poly h, int len, int ecart, BOOLEAN simplified)
+static int
+add_to_reductors (slimgb_alg * c, poly h, int len, int ecart,
+		  BOOLEAN simplified)
 {
   //inDebug(h);
-  assume(lenS_correct(c->strat));
-  assume(len==pLength(h));
+  assume (lenS_correct (c->strat));
+  assume (len == pLength (h));
   int i;
 //   if (c->isDifficultField)
@@ -905,171 +1020,179 @@
 //     i=simple_posInS(c->strat,h,len,c->isDifficultField);
 
-  LObject P; memset(&P,0,sizeof(P));
-  P.tailRing=c->r;
-  P.p=h; /*p_Copy(h,c->r);*/
-  P.ecart=ecart;
-  P.FDeg=pFDeg(P.p,c->r);
+  LObject P;
+  memset (&P, 0, sizeof (P));
+  P.tailRing = c->r;
+  P.p = h;			/*p_Copy(h,c->r); */
+  P.ecart = ecart;
+  P.FDeg = pFDeg (P.p, c->r);
   if (!(simplified))
   {
-      if (!rField_is_Zp(c->r))
-      {
-        p_Cleardenom(P.p,c->r);
-        //p_Content(P.p,c->r ); //is a duplicate call, but belongs here
-
-      }
-      else
-        pNorm(P.p);
-    pNormalize(P.p);
-  }
-  wlen_type pq=pQuality(h,c,len);
-  i=simple_posInS(c->strat,h,len,pq);
-  c->strat->enterS(P,i,c->strat,-1);
-
-  c->strat->lenS[i]=len;
-  assume(pLength(c->strat->S[i])==c->strat->lenS[i]);
-  if(c->strat->lenSw!=NULL)
-    c->strat->lenSw[i]=pq;
+    if (!rField_is_Zp (c->r))
+    {
+      p_Cleardenom (P.p, c->r);
+      //p_Content(P.p,c->r ); //is a duplicate call, but belongs here
+
+    }
+    else
+      pNorm (P.p);
+    pNormalize (P.p);
+  }
+  wlen_type pq = pQuality (h, c, len);
+  i = simple_posInS (c->strat, h, len, pq);
+  c->strat->enterS (P, i, c->strat, -1);
+
+  c->strat->lenS[i] = len;
+  assume (pLength (c->strat->S[i]) == c->strat->lenS[i]);
+  if (c->strat->lenSw != NULL)
+    c->strat->lenSw[i] = pq;
 
   return i;
 }
 
-static void length_one_crit(slimgb_alg* c, int pos, int len)
+static void
+length_one_crit (slimgb_alg * c, int pos, int len)
 {
   if (c->nc)
     return;
-  if (len==1)
+  if (len == 1)
   {
     int i;
-    for ( i=0;i<pos;i++)
-    {
-      if (c->lengths[i]==1)
-        c->states[pos][i]=HASTREP;
-    }
-    for ( i=pos+1;i<c->n;i++)
-    {
-      if (c->lengths[i]==1)
-        c->states[i][pos]=HASTREP;
+    for (i = 0; i < pos; i++)
+    {
+      if (c->lengths[i] == 1)
+	c->states[pos][i] = HASTREP;
+    }
+    for (i = pos + 1; i < c->n; i++)
+    {
+      if (c->lengths[i] == 1)
+	c->states[i][pos] = HASTREP;
     }
     if (!c->nc)
-      shorten_tails(c,c->S->m[pos]);
-  }
-}
-
-static void move_forward_in_S(int old_pos, int new_pos,kStrategy strat)
-{
-  assume(old_pos>=new_pos);
-  poly p=strat->S[old_pos];
-  int ecart=strat->ecartS[old_pos];
-  long sev=strat->sevS[old_pos];
-  int s_2_r=strat->S_2_R[old_pos];
-  int length=strat->lenS[old_pos];
-  assume(length==pLength(strat->S[old_pos]));
+      shorten_tails (c, c->S->m[pos]);
+  }
+}
+
+static void
+move_forward_in_S (int old_pos, int new_pos, kStrategy strat)
+{
+  assume (old_pos >= new_pos);
+  poly p = strat->S[old_pos];
+  int ecart = strat->ecartS[old_pos];
+  long sev = strat->sevS[old_pos];
+  int s_2_r = strat->S_2_R[old_pos];
+  int length = strat->lenS[old_pos];
+  assume (length == pLength (strat->S[old_pos]));
   wlen_type length_w;
-  if(strat->lenSw!=NULL)
-    length_w=strat->lenSw[old_pos];
+  if (strat->lenSw != NULL)
+    length_w = strat->lenSw[old_pos];
   int i;
-  for (i=old_pos; i>new_pos; i--)
-  {
-    strat->S[i] = strat->S[i-1];
-    strat->ecartS[i] = strat->ecartS[i-1];
-    strat->sevS[i] = strat->sevS[i-1];
-    strat->S_2_R[i] = strat->S_2_R[i-1];
-  }
-  if (strat->lenS!=NULL)
-    for (i=old_pos; i>new_pos; i--)
-      strat->lenS[i] = strat->lenS[i-1];
-  if (strat->lenSw!=NULL)
-    for (i=old_pos; i>new_pos; i--)
-      strat->lenSw[i] = strat->lenSw[i-1];
-
-  strat->S[new_pos]=p;
-  strat->ecartS[new_pos]=ecart;
-  strat->sevS[new_pos]=sev;
-  strat->S_2_R[new_pos]=s_2_r;
-  strat->lenS[new_pos]=length;
-  if(strat->lenSw!=NULL)
-    strat->lenSw[new_pos]=length_w;
+  for (i = old_pos; i > new_pos; i--)
+  {
+    strat->S[i] = strat->S[i - 1];
+    strat->ecartS[i] = strat->ecartS[i - 1];
+    strat->sevS[i] = strat->sevS[i - 1];
+    strat->S_2_R[i] = strat->S_2_R[i - 1];
+  }
+  if (strat->lenS != NULL)
+    for (i = old_pos; i > new_pos; i--)
+      strat->lenS[i] = strat->lenS[i - 1];
+  if (strat->lenSw != NULL)
+    for (i = old_pos; i > new_pos; i--)
+      strat->lenSw[i] = strat->lenSw[i - 1];
+
+  strat->S[new_pos] = p;
+  strat->ecartS[new_pos] = ecart;
+  strat->sevS[new_pos] = sev;
+  strat->S_2_R[new_pos] = s_2_r;
+  strat->lenS[new_pos] = length;
+  if (strat->lenSw != NULL)
+    strat->lenSw[new_pos] = length_w;
   //assume(lenS_correct(strat));
 }
 
-static void move_backward_in_S(int old_pos, int new_pos,kStrategy strat)
-{
-  assume(old_pos<=new_pos);
-  poly p=strat->S[old_pos];
-  int ecart=strat->ecartS[old_pos];
-  long sev=strat->sevS[old_pos];
-  int s_2_r=strat->S_2_R[old_pos];
-  int length=strat->lenS[old_pos];
-  assume(length==pLength(strat->S[old_pos]));
+static void
+move_backward_in_S (int old_pos, int new_pos, kStrategy strat)
+{
+  assume (old_pos <= new_pos);
+  poly p = strat->S[old_pos];
+  int ecart = strat->ecartS[old_pos];
+  long sev = strat->sevS[old_pos];
+  int s_2_r = strat->S_2_R[old_pos];
+  int length = strat->lenS[old_pos];
+  assume (length == pLength (strat->S[old_pos]));
   wlen_type length_w;
-  if(strat->lenSw!=NULL)
-    length_w=strat->lenSw[old_pos];
+  if (strat->lenSw != NULL)
+    length_w = strat->lenSw[old_pos];
   int i;
-  for (i=old_pos; i<new_pos; i++)
-  {
-    strat->S[i] = strat->S[i+1];
-    strat->ecartS[i] = strat->ecartS[i+1];
-    strat->sevS[i] = strat->sevS[i+1];
-    strat->S_2_R[i] = strat->S_2_R[i+1];
-  }
-  if (strat->lenS!=NULL)
-    for (i=old_pos; i<new_pos; i++)
-      strat->lenS[i] = strat->lenS[i+1];
-  if (strat->lenSw!=NULL)
-    for (i=old_pos; i<new_pos; i++)
-      strat->lenSw[i] = strat->lenSw[i+1];
-
-  strat->S[new_pos]=p;
-  strat->ecartS[new_pos]=ecart;
-  strat->sevS[new_pos]=sev;
-  strat->S_2_R[new_pos]=s_2_r;
-  strat->lenS[new_pos]=length;
-  if(strat->lenSw!=NULL)
-    strat->lenSw[new_pos]=length_w;
+  for (i = old_pos; i < new_pos; i++)
+  {
+    strat->S[i] = strat->S[i + 1];
+    strat->ecartS[i] = strat->ecartS[i + 1];
+    strat->sevS[i] = strat->sevS[i + 1];
+    strat->S_2_R[i] = strat->S_2_R[i + 1];
+  }
+  if (strat->lenS != NULL)
+    for (i = old_pos; i < new_pos; i++)
+      strat->lenS[i] = strat->lenS[i + 1];
+  if (strat->lenSw != NULL)
+    for (i = old_pos; i < new_pos; i++)
+      strat->lenSw[i] = strat->lenSw[i + 1];
+
+  strat->S[new_pos] = p;
+  strat->ecartS[new_pos] = ecart;
+  strat->sevS[new_pos] = sev;
+  strat->S_2_R[new_pos] = s_2_r;
+  strat->lenS[new_pos] = length;
+  if (strat->lenSw != NULL)
+    strat->lenSw[new_pos] = length_w;
   //assume(lenS_correct(strat));
 }
 
-static int* make_connections(int from, int to, poly bound, slimgb_alg* c)
-{
-  ideal I=c->S;
-  int* cans=(int*) omalloc(c->n*sizeof(int));
-  int* connected=(int*) omalloc(c->n*sizeof(int));
-  cans[0]=to;
-  int cans_length=1;
-  connected[0]=from;
-  int last_cans_pos=-1;
-  int connected_length=1;
-  long neg_bounds_short= ~p_GetShortExpVector(bound,c->r);
-
-  int not_yet_found=cans_length;
-  int con_checked=0;
+static int *
+make_connections (int from, int to, poly bound, slimgb_alg * c)
+{
+  ideal I = c->S;
+  int *cans = (int *) omalloc (c->n * sizeof (int));
+  int *connected = (int *) omalloc (c->n * sizeof (int));
+  cans[0] = to;
+  int cans_length = 1;
+  connected[0] = from;
+  int last_cans_pos = -1;
+  int connected_length = 1;
+  long neg_bounds_short = ~p_GetShortExpVector (bound, c->r);
+
+  int not_yet_found = cans_length;
+  int con_checked = 0;
   int pos;
 
-  while(TRUE)
-  {
-    if ((con_checked<connected_length)&& (not_yet_found>0))
-    {
-      pos=connected[con_checked];
-      for(int i=0;i<cans_length;i++)
-      {
-        if (cans[i]<0) continue;
-        //FIXME: triv. syz. does not hold on noncommutative, check it for modules
-        if ((has_t_rep(pos,cans[i],c)) ||((!rIsPluralRing(c->r))&&(trivial_syzygie(pos,cans[i],bound,c))))
-{
-          connected[connected_length]=cans[i];
-          connected_length++;
-          cans[i]=-1;
-          --not_yet_found;
-
-          if (connected[connected_length-1]==to)
-          {
-            if (connected_length<c->n)
-            {
-              connected[connected_length]=-1;
-            }
-            omfree(cans);
-            return connected;
-          }
-        }
+  while (TRUE)
+  {
+    if ((con_checked < connected_length) && (not_yet_found > 0))
+    {
+      pos = connected[con_checked];
+      for (int i = 0; i < cans_length; i++)
+      {
+	if (cans[i] < 0)
+	  continue;
+	//FIXME: triv. syz. does not hold on noncommutative, check it for modules
+	if ((has_t_rep (pos, cans[i], c))
+	    || ((!rIsPluralRing (c->r))
+		&& (trivial_syzygie (pos, cans[i], bound, c))))
+	{
+	  connected[connected_length] = cans[i];
+	  connected_length++;
+	  cans[i] = -1;
+	  --not_yet_found;
+
+	  if (connected[connected_length - 1] == to)
+	  {
+	    if (connected_length < c->n)
+	    {
+	      connected[connected_length] = -1;
+	    }
+	    omfree (cans);
+	    return connected;
+	  }
+	}
       }
       con_checked++;
@@ -1077,89 +1200,95 @@
     else
     {
-      for(last_cans_pos++;last_cans_pos<=c->n;last_cans_pos++)
-      {
-        if (last_cans_pos==c->n)
-        {
-          if (connected_length<c->n)
-          {
-            connected[connected_length]=-1;
-          }
-          omfree(cans);
-          return connected;
-        }
-        if ((last_cans_pos==from)||(last_cans_pos==to))
-          continue;
-        if(p_LmShortDivisibleBy(I->m[last_cans_pos],c->short_Exps[last_cans_pos],bound,neg_bounds_short,c->r))
-        {
-          cans[cans_length]=last_cans_pos;
-          cans_length++;
-          break;
-        }
+      for (last_cans_pos++; last_cans_pos <= c->n; last_cans_pos++)
+      {
+	if (last_cans_pos == c->n)
+	{
+	  if (connected_length < c->n)
+	  {
+	    connected[connected_length] = -1;
+	  }
+	  omfree (cans);
+	  return connected;
+	}
+	if ((last_cans_pos == from) || (last_cans_pos == to))
+	  continue;
+	if (p_LmShortDivisibleBy
+	    (I->m[last_cans_pos], c->short_Exps[last_cans_pos], bound,
+	     neg_bounds_short, c->r))
+	{
+	  cans[cans_length] = last_cans_pos;
+	  cans_length++;
+	  break;
+	}
       }
       not_yet_found++;
-      for (int i=0;i<con_checked;i++)
-      {
-        if (has_t_rep(connected[i],last_cans_pos,c))
-        {
-          connected[connected_length]=last_cans_pos;
-          connected_length++;
-          cans[cans_length-1]=-1;
-          --not_yet_found;
-          if (connected[connected_length-1]==to)
-          {
-            if (connected_length<c->n)
-            {
-              connected[connected_length]=-1;
-            }
-            omfree(cans);
-            return connected;
-          }
-          break;
-        }
-      }
-    }
-  }
-  if (connected_length<c->n)
-  {
-    connected[connected_length]=-1;
-  }
-  omfree(cans);
+      for (int i = 0; i < con_checked; i++)
+      {
+	if (has_t_rep (connected[i], last_cans_pos, c))
+	{
+	  connected[connected_length] = last_cans_pos;
+	  connected_length++;
+	  cans[cans_length - 1] = -1;
+	  --not_yet_found;
+	  if (connected[connected_length - 1] == to)
+	  {
+	    if (connected_length < c->n)
+	    {
+	      connected[connected_length] = -1;
+	    }
+	    omfree (cans);
+	    return connected;
+	  }
+	  break;
+	}
+      }
+    }
+  }
+  if (connected_length < c->n)
+  {
+    connected[connected_length] = -1;
+  }
+  omfree (cans);
   return connected;
 }
+
 #ifdef HEAD_BIN
-static inline poly p_MoveHead(poly p, omBin b)
+static inline poly
+p_MoveHead (poly p, omBin b)
 {
   poly np;
-  omTypeAllocBin(poly, np, b);
-  memmove(np, p, b->sizeW*sizeof(long));
-  omFreeBinAddr(p);
+  omTypeAllocBin (poly, np, b);
+  memmove (np, p, b->sizeW * sizeof (long));
+  omFreeBinAddr (p);
   return np;
 }
 #endif
 
-static void replace_pair(int & i, int & j,slimgb_alg* c)
-{
-  if (i<0) return;
-  c->soon_free=NULL;
+static void
+replace_pair (int &i, int &j, slimgb_alg * c)
+{
+  if (i < 0)
+    return;
+  c->soon_free = NULL;
   int syz_deg;
-  poly lm=pOne();
-
-  pLcm(c->S->m[i], c->S->m[j], lm);
-  pSetm(lm);
-
-  int* i_con =make_connections(i,j,lm,c);
-
-  for (int n=0;((n<c->n) && (i_con[n]>=0));n++)
-  {
-    if (i_con[n]==j)
-    {
-      now_t_rep(i,j,c);
-      omfree(i_con);
-      p_Delete(&lm,c->r);
+  poly lm = pOne ();
+
+  pLcm (c->S->m[i], c->S->m[j], lm);
+  pSetm (lm);
+
+  int *i_con = make_connections (i, j, lm, c);
+
+  for (int n = 0; ((n < c->n) && (i_con[n] >= 0)); n++)
+  {
+    if (i_con[n] == j)
+    {
+      now_t_rep (i, j, c);
+      omfree (i_con);
+      p_Delete (&lm, c->r);
       return;
     }
   }
 
-  int* j_con =make_connections(j,i,lm,c);
+  int *j_con = make_connections (j, i, lm, c);
 
 //   if(c->n>1)
@@ -1172,63 +1301,72 @@
 //         j=j_con[1];
 //     }
- // }
-
-  int sugar=syz_deg=c->pTotaldegree(lm);
-
-  p_Delete(&lm, c->r);
-    if(c->T_deg_full)//Sugar
-    {
-      int t_i=c->T_deg_full[i]-c->T_deg[i];
-      int t_j=c->T_deg_full[j]-c->T_deg[j];
-      sugar+=si_max(t_i,t_j);
-      //Print("\n max: %d\n",max(t_i,t_j));
-    }
-
-  for (int m=0;((m<c->n) && (i_con[m]>=0));m++)
-  {
-    if(c->T_deg_full!=NULL)
-    {
-        int s1=c->T_deg_full[i_con[m]]+syz_deg-c->T_deg[i_con[m]];
-        if (s1>sugar) continue;
-    }
-    if (c->weighted_lengths[i_con[m]]<c->weighted_lengths[i])
-        i=i_con[m];
-    }
-    for (int m=0;((m<c->n) && (j_con[m]>=0));m++)
-    {
-        if (c->T_deg_full!=NULL)
-        {
-        int s1=c->T_deg_full[j_con[m]]+syz_deg-c->T_deg[j_con[m]];
-        if (s1>sugar) continue;}
-        if (c->weighted_lengths[j_con[m]]<c->weighted_lengths[j])
-            j=j_con[m];
-    }
-
-     //can also try dependend search
-  omfree(i_con);
-  omfree(j_con);
+  // }
+
+  int sugar = syz_deg = c->pTotaldegree (lm);
+
+  p_Delete (&lm, c->r);
+  if (c->T_deg_full)		//Sugar
+  {
+    int t_i = c->T_deg_full[i] - c->T_deg[i];
+    int t_j = c->T_deg_full[j] - c->T_deg[j];
+    sugar += si_max (t_i, t_j);
+    //Print("\n max: %d\n",max(t_i,t_j));
+  }
+
+  for (int m = 0; ((m < c->n) && (i_con[m] >= 0)); m++)
+  {
+    if (c->T_deg_full != NULL)
+    {
+      int s1 = c->T_deg_full[i_con[m]] + syz_deg - c->T_deg[i_con[m]];
+      if (s1 > sugar)
+	continue;
+    }
+    if (c->weighted_lengths[i_con[m]] < c->weighted_lengths[i])
+      i = i_con[m];
+  }
+  for (int m = 0; ((m < c->n) && (j_con[m] >= 0)); m++)
+  {
+    if (c->T_deg_full != NULL)
+    {
+      int s1 = c->T_deg_full[j_con[m]] + syz_deg - c->T_deg[j_con[m]];
+      if (s1 > sugar)
+	continue;
+    }
+    if (c->weighted_lengths[j_con[m]] < c->weighted_lengths[j])
+      j = j_con[m];
+  }
+
+  //can also try dependend search
+  omfree (i_con);
+  omfree (j_con);
   return;
 }
 
-static void add_later(poly p, const char* prot, slimgb_alg* c)
-{
-    int i=0;
-    //check, if it is already in the queue
-
-    while(c->add_later->m[i]!=NULL)
-    {
-        if (p_LmEqual(c->add_later->m[i],p,c->r))
-            return;
-        i++;
-    }
-    if (TEST_OPT_PROT)
-        PrintS(prot);
-    c->add_later->m[i]=p;
-}
-static int simple_posInS (kStrategy strat, poly p,int len, wlen_type wlen)
-{
-  if(strat->sl==-1) return 0;
-  if (strat->lenSw) return pos_helper(strat,p,(wlen_type) wlen,(wlen_set) strat->lenSw,strat->S);
-  return pos_helper(strat,p,len,strat->lenS,strat->S);
+static void
+add_later (poly p, const char *prot, slimgb_alg * c)
+{
+  int i = 0;
+  //check, if it is already in the queue
+
+  while (c->add_later->m[i] != NULL)
+  {
+    if (p_LmEqual (c->add_later->m[i], p, c->r))
+      return;
+    i++;
+  }
+  if (TEST_OPT_PROT)
+    PrintS (prot);
+  c->add_later->m[i] = p;
+}
+
+static int
+simple_posInS (kStrategy strat, poly p, int len, wlen_type wlen)
+{
+  if (strat->sl == -1)
+    return 0;
+  if (strat->lenSw)
+    return pos_helper (strat, p, (wlen_type) wlen, (wlen_set) strat->lenSw,
+		       strat->S);
+  return pos_helper (strat, p, len, strat->lenS, strat->S);
 }
 
@@ -1237,15 +1375,17 @@
  *divides the leading term of some S[i] it will be canceled
  */
-static inline void clearS (poly p, unsigned long p_sev,int l, int* at, int* k,
-                           kStrategy strat)
-{
-  assume(p_sev == pGetShortExpVector(p));
-  if (!pLmShortDivisibleBy(p,p_sev, strat->S[*at], ~ strat->sevS[*at])) return;
-  if (l>=strat->lenS[*at]) return;
+static inline void
+clearS (poly p, unsigned long p_sev, int l, int *at, int *k, kStrategy strat)
+{
+  assume (p_sev == pGetShortExpVector (p));
+  if (!pLmShortDivisibleBy (p, p_sev, strat->S[*at], ~strat->sevS[*at]))
+    return;
+  if (l >= strat->lenS[*at])
+    return;
   if (TEST_OPT_PROT)
-    PrintS("!");
-  mflush();
+    PrintS ("!");
+  mflush ();
   //pDelete(&strat->S[*at]);
-  deleteInS((*at),strat);
+  deleteInS ((*at), strat);
   (*at)--;
   (*k)--;
@@ -1253,97 +1393,117 @@
 }
 
-static int iq_crit(const void* ap,const void* bp)
-{
-  sorted_pair_node* a=*((sorted_pair_node**)ap);
-  sorted_pair_node* b=*((sorted_pair_node**)bp);
-  assume(a->i>a->j);
-  assume(b->i>b->j);
-
-  if (a->deg<b->deg) return -1;
-  if (a->deg>b->deg) return 1;
-  int comp=pLmCmp(a->lcm_of_lm, b->lcm_of_lm);
-  if(comp!=0)
+static int
+iq_crit (const void *ap, const void *bp)
+{
+  sorted_pair_node *a = *((sorted_pair_node **) ap);
+  sorted_pair_node *b = *((sorted_pair_node **) bp);
+  assume (a->i > a->j);
+  assume (b->i > b->j);
+
+  if (a->deg < b->deg)
+    return -1;
+  if (a->deg > b->deg)
+    return 1;
+  int comp = pLmCmp (a->lcm_of_lm, b->lcm_of_lm);
+  if (comp != 0)
     return comp;
-  if (a->expected_length<b->expected_length) return -1;
-  if (a->expected_length>b->expected_length) return 1;
-  if (a->j>b->j) return 1;
-  if (a->j<b->j) return -1;
+  if (a->expected_length < b->expected_length)
+    return -1;
+  if (a->expected_length > b->expected_length)
+    return 1;
+  if (a->j > b->j)
+    return 1;
+  if (a->j < b->j)
+    return -1;
   return 0;
 }
-static wlen_type coeff_mult_size_estimate(int s1, int s2, ring r)
-{
-    if (rField_is_Q(r)) return s1+s2;
-    else return s1*s2;
-}
-static wlen_type pair_weighted_length(int i, int j, slimgb_alg* c)
-{
-    if ((c->isDifficultField) && (c->eliminationProblem))  {
-        int c1=slim_nsize(p_GetCoeff(c->S->m[i],c->r),c->r);
-        int c2=slim_nsize(p_GetCoeff(c->S->m[j],c->r),c->r);
-        wlen_type el1=c->weighted_lengths[i]/c1;
-        assume(el1!=0);
-        assume(c->weighted_lengths[i] %c1==0);
-        wlen_type el2=c->weighted_lengths[j]/c2;
-        assume(el2!=0);
-        assume(c->weighted_lengths[j] %c2==0);
-        //should be * for function fields
-        //return (c1+c2) * (el1+el2-2);
-        wlen_type res=coeff_mult_size_estimate(c1,c2,c->r);
-        res*=el1+el2-2;
-        return res;
-
-    }
-    if (c->isDifficultField) {
-        //int cs=slim_nsize(p_GetCoeff(c->S->m[i],c->r),c->r)+
-        //    slim_nsize(p_GetCoeff(c->S->m[j],c->r),c->r);
-        if(!(TEST_V_COEFSTRAT))
-        {
-        wlen_type cs=
-            coeff_mult_size_estimate(
-                slim_nsize(p_GetCoeff(c->S->m[i],c->r),c->r),
-                slim_nsize(p_GetCoeff(c->S->m[j],c->r),c->r),c->r);
-        return (wlen_type)(c->lengths[i]+c->lengths[j]-2)*
-            (wlen_type)cs;}
-            else
-            {
-
-            wlen_type cs=
-            coeff_mult_size_estimate(
-                slim_nsize(p_GetCoeff(c->S->m[i],c->r),c->r),
-                slim_nsize(p_GetCoeff(c->S->m[j],c->r),c->r),c->r);
-            cs*=cs;
-        return (wlen_type)(c->lengths[i]+c->lengths[j]-2)*
-            (wlen_type)cs;
-            }
-    }
-    if (c->eliminationProblem) {
-
-        return (c->weighted_lengths[i]+c->weighted_lengths[j]-2);
-    }
-    return c->lengths[i]+c->lengths[j]-2;
-
-}
-sorted_pair_node** add_to_basis_ideal_quotient(poly h, slimgb_alg* c, int* ip)
-{
-  p_Test(h,c->r);
-  assume(h!=NULL);
-  poly got=gcd_of_terms(h,c->r);
-  if((got!=NULL) &&(TEST_V_UPTORADICAL)) {
-    poly copy=p_Copy(got,c->r);
+
+static wlen_type
+coeff_mult_size_estimate (int s1, int s2, ring r)
+{
+  if (rField_is_Q (r))
+    return s1 + s2;
+  else
+    return s1 * s2;
+}
+
+static wlen_type
+pair_weighted_length (int i, int j, slimgb_alg * c)
+{
+  if ((c->isDifficultField) && (c->eliminationProblem))
+  {
+    int c1 = slim_nsize (p_GetCoeff (c->S->m[i], c->r), c->r);
+    int c2 = slim_nsize (p_GetCoeff (c->S->m[j], c->r), c->r);
+    wlen_type el1 = c->weighted_lengths[i] / c1;
+    assume (el1 != 0);
+    assume (c->weighted_lengths[i] % c1 == 0);
+    wlen_type el2 = c->weighted_lengths[j] / c2;
+    assume (el2 != 0);
+    assume (c->weighted_lengths[j] % c2 == 0);
+    //should be * for function fields
+    //return (c1+c2) * (el1+el2-2);
+    wlen_type res = coeff_mult_size_estimate (c1, c2, c->r);
+    res *= el1 + el2 - 2;
+    return res;
+
+  }
+  if (c->isDifficultField)
+  {
+    //int cs=slim_nsize(p_GetCoeff(c->S->m[i],c->r),c->r)+
+    //    slim_nsize(p_GetCoeff(c->S->m[j],c->r),c->r);
+    if (!(TEST_V_COEFSTRAT))
+    {
+      wlen_type cs =
+	coeff_mult_size_estimate (slim_nsize
+				  (p_GetCoeff (c->S->m[i], c->r), c->r),
+				  slim_nsize (p_GetCoeff (c->S->m[j], c->r),
+					      c->r), c->r);
+      return (wlen_type) (c->lengths[i] + c->lengths[j] - 2) * (wlen_type) cs;
+    }
+    else
+    {
+
+      wlen_type cs =
+	coeff_mult_size_estimate (slim_nsize
+				  (p_GetCoeff (c->S->m[i], c->r), c->r),
+				  slim_nsize (p_GetCoeff (c->S->m[j], c->r),
+					      c->r), c->r);
+      cs *= cs;
+      return (wlen_type) (c->lengths[i] + c->lengths[j] - 2) * (wlen_type) cs;
+    }
+  }
+  if (c->eliminationProblem)
+  {
+
+    return (c->weighted_lengths[i] + c->weighted_lengths[j] - 2);
+  }
+  return c->lengths[i] + c->lengths[j] - 2;
+
+}
+
+sorted_pair_node **
+add_to_basis_ideal_quotient (poly h, slimgb_alg * c, int *ip)
+{
+  p_Test (h, c->r);
+  assume (h != NULL);
+  poly got = gcd_of_terms (h, c->r);
+  if ((got != NULL) && (TEST_V_UPTORADICAL))
+  {
+    poly copy = p_Copy (got, c->r);
     //p_wrp(got,c->r);
-    BOOLEAN changed=monomial_root(got,c->r);
+    BOOLEAN changed = monomial_root (got, c->r);
     if (changed)
     {
-         poly div_by=pDivide(copy, got);
-         poly iter=h;
-         while(iter)
-         {
-            pExpVectorSub(iter,div_by);
-            pIter(iter);
-         }
-         p_Delete(&div_by, c->r);
-         PrintS("U");
-    }
-    p_Delete(&copy,c->r);
+      poly div_by = pDivide (copy, got);
+      poly iter = h;
+      while (iter)
+      {
+	pExpVectorSub (iter, div_by);
+	pIter (iter);
+      }
+      p_Delete (&div_by, c->r);
+      PrintS ("U");
+    }
+    p_Delete (&copy, c->r);
   }
 
@@ -1351,125 +1511,131 @@
 //  BOOLEAN corr=lenS_correct(c->strat);
   int sugar;
-  int ecart=0;
+  int ecart = 0;
   ++(c->n);
   ++(c->S->ncols);
-  int i,j;
-  i=c->n-1;
-  sorted_pair_node** nodes=(sorted_pair_node**) omalloc(sizeof(sorted_pair_node*)*i);
-  int spc=0;
-  if(c->n>c->array_lengths)
-  {
-    c->array_lengths=c->array_lengths*2;
-    assume(c->array_lengths>=c->n);
-    ENLARGE(c->T_deg, int);
-    ENLARGE(c->tmp_pair_lm,poly);
-    ENLARGE(c->tmp_spn,sorted_pair_node*);
-
-    ENLARGE(c->short_Exps,long);
-    ENLARGE(c->lengths,int);
-    #ifndef HAVE_BOOST
-    #ifndef USE_STDVECBOOL
-
-    ENLARGE(c->states, char*);
-    #endif
-    #endif
-    ENLARGE(c->gcd_of_terms,poly);
+  int i, j;
+  i = c->n - 1;
+  sorted_pair_node **nodes =
+    (sorted_pair_node **) omalloc (sizeof (sorted_pair_node *) * i);
+  int spc = 0;
+  if (c->n > c->array_lengths)
+  {
+    c->array_lengths = c->array_lengths * 2;
+    assume (c->array_lengths >= c->n);
+    ENLARGE (c->T_deg, int);
+    ENLARGE (c->tmp_pair_lm, poly);
+    ENLARGE (c->tmp_spn, sorted_pair_node *);
+
+    ENLARGE (c->short_Exps, long);
+    ENLARGE (c->lengths, int);
+#ifndef HAVE_BOOST
+#ifndef USE_STDVECBOOL
+
+    ENLARGE (c->states, char *);
+#endif
+#endif
+    ENLARGE (c->gcd_of_terms, poly);
     //if (c->weighted_lengths!=NULL) {
-    ENLARGE(c->weighted_lengths,wlen_type);
+    ENLARGE (c->weighted_lengths, wlen_type);
     //}
     //ENLARGE(c->S->m,poly);
   }
-  pEnlargeSet(&c->S->m,c->n-1,1);
+  pEnlargeSet (&c->S->m, c->n - 1, 1);
   if (c->T_deg_full)
-    ENLARGE(c->T_deg_full,int);
-  sugar=c->T_deg[i]=c->pTotaldegree(h);
-  if(c->T_deg_full)
-  {
-    sugar=c->T_deg_full[i]=c->pTotaldegree_full(h);
-    ecart=sugar-c->T_deg[i];
-    assume(ecart>=0);
-  }
-  c->tmp_pair_lm[i]=pOne_Special(c->r);
-
-  c->tmp_spn[i]=(sorted_pair_node*) omalloc(sizeof(sorted_pair_node));
-
-  c->lengths[i]=pLength(h);
+    ENLARGE (c->T_deg_full, int);
+  sugar = c->T_deg[i] = c->pTotaldegree (h);
+  if (c->T_deg_full)
+  {
+    sugar = c->T_deg_full[i] = c->pTotaldegree_full (h);
+    ecart = sugar - c->T_deg[i];
+    assume (ecart >= 0);
+  }
+  c->tmp_pair_lm[i] = pOne_Special (c->r);
+
+  c->tmp_spn[i] = (sorted_pair_node *) omalloc (sizeof (sorted_pair_node));
+
+  c->lengths[i] = pLength (h);
 
   //necessary for correct weighted length
 
-  if (!rField_is_Zp(c->r))
-  {
-    p_Cleardenom(h, c->r);
+  if (!rField_is_Zp (c->r))
+  {
+    p_Cleardenom (h, c->r);
     //p_Content(h,c->r); //is a duplicate call, but belongs here
   }
   else
-    pNorm(h);
-  pNormalize(h);
-
-  c->weighted_lengths[i]=pQuality(h, c, c->lengths[i]);
-  c->gcd_of_terms[i]=got;
-  #ifdef HAVE_BOOST
-    c->states.push_back(dynamic_bitset<>(i));
-
-  #else
-  #ifdef USE_STDVECBOOL
-
-    c->states.push_back(vector<bool>(i));
-
-  #else
-  if (i>0)
-    c->states[i]=(char*)  omalloc(i*sizeof(char));
+    pNorm (h);
+  pNormalize (h);
+
+  c->weighted_lengths[i] = pQuality (h, c, c->lengths[i]);
+  c->gcd_of_terms[i] = got;
+#ifdef HAVE_BOOST
+  c->states.push_back (dynamic_bitset <> (i));
+
+#else
+#ifdef USE_STDVECBOOL
+
+  c->states.push_back (vector < bool > (i));
+
+#else
+  if (i > 0)
+    c->states[i] = (char *) omalloc (i * sizeof (char));
   else
-    c->states[i]=NULL;
-  #endif
-  #endif
-
-  c->S->m[i]=h;
-  c->short_Exps[i]=p_GetShortExpVector(h,c->r);
+    c->states[i] = NULL;
+#endif
+#endif
+
+  c->S->m[i] = h;
+  c->short_Exps[i] = p_GetShortExpVector (h, c->r);
 
 #undef ENLARGE
-  if (p_GetComp(h,currRing)<=c->syz_comp)
-  {
-  for (j=0;j<i;j++)
-  {
-
-
-    #ifndef HAVE_BOOST
-    c->states[i][j]=UNCALCULATED;
-    #endif
-    assume(p_LmDivisibleBy(c->S->m[i],c->S->m[j],c->r)==
-     p_LmShortDivisibleBy(c->S->m[i],c->short_Exps[i],c->S->m[j],~(c->short_Exps[j]),c->r));
-
-    if (_p_GetComp(c->S->m[i],c->r)!=_p_GetComp(c->S->m[j],c->r))
-    {
-      //c->states[i][j]=UNCALCULATED;
-      //WARNUNG: be careful
-      continue;
-    }
-    else
-    if ((!c->nc) && (c->lengths[i]==1) && (c->lengths[j]==1))
-    {
-      c->states[i][j]=HASTREP;
-    }
-    else if (( (!c->nc) || (c->is_homog && rIsSCA(c->r) ) ) &&  (pHasNotCF(c->S->m[i],c->S->m[j])))
+  if (p_GetComp (h, currRing) <= c->syz_comp)
+  {
+    for (j = 0; j < i; j++)
+    {
+
+
+#ifndef HAVE_BOOST
+      c->states[i][j] = UNCALCULATED;
+#endif
+      assume (p_LmDivisibleBy (c->S->m[i], c->S->m[j], c->r) ==
+	      p_LmShortDivisibleBy (c->S->m[i], c->short_Exps[i], c->S->m[j],
+				    ~(c->short_Exps[j]), c->r));
+
+      if (_p_GetComp (c->S->m[i], c->r) != _p_GetComp (c->S->m[j], c->r))
+      {
+	//c->states[i][j]=UNCALCULATED;
+	//WARNUNG: be careful
+	continue;
+      }
+      else if ((!c->nc) && (c->lengths[i] == 1) && (c->lengths[j] == 1))
+      {
+	c->states[i][j] = HASTREP;
+      }
+      else if (((!c->nc) || (c->is_homog && rIsSCA (c->r)))
+	       && (pHasNotCF (c->S->m[i], c->S->m[j])))
 //     else if ((!(c->nc)) &&  (pHasNotCF(c->S->m[i],c->S->m[j])))
-    {
-      c->easy_product_crit++;
-      c->states[i][j]=HASTREP;
-      continue;
-    }
-    else if(extended_product_criterion(c->S->m[i],c->gcd_of_terms[i],c->S->m[j],c->gcd_of_terms[j],c))
-    {
-      c->states[i][j]=HASTREP;
-      c->extended_product_crit++;
-      //PrintS("E");
-    }
+      {
+	c->easy_product_crit++;
+	c->states[i][j] = HASTREP;
+	continue;
+      }
+      else
+	if (extended_product_criterion
+	    (c->S->m[i], c->gcd_of_terms[i], c->S->m[j], c->gcd_of_terms[j],
+	     c))
+      {
+	c->states[i][j] = HASTREP;
+	c->extended_product_crit++;
+	//PrintS("E");
+      }
       //  if (c->states[i][j]==UNCALCULATED)
       //  {
 
-    if ((TEST_V_FINDMONOM) &&(!c->nc)) {
-        //PrintS("COMMU");
-       //  if (c->lengths[i]==c->lengths[j])
-       //  {
+      if ((TEST_V_FINDMONOM) && (!c->nc))
+      {
+	//PrintS("COMMU");
+	//  if (c->lengths[i]==c->lengths[j])
+	//  {
 //             poly short_s=ksCreateShortSpoly(c->S->m[i],c->S->m[j],c->r);
 //             if (short_s==NULL)
